"""
This module gives you access to the UI.
"""

import PytoClasses
import mainthread
from time import sleep

def mainLoop():
    """
    This runs a loop while the UI is shown to keep the program running. You should always call this function after showing an interactive UI.
    """
    
    PytoClasses.ConsoleViewController.isMainLoopRunning = True
    
    while (PytoClasses.ConsoleViewController.isMainLoopRunning):
        sleep(1)

def showViewController(viewController):
    """
    Shows the given View controller.
        
    Args:
        viewController: An `UIViewController` to show.
    """
    
    PytoClasses.ConsoleViewController.visible.showViewController(viewController)

def closeViewController():
    """
    Closes the currently presented View controller.
    """
    
    PytoClasses.ConsoleViewController.visible.closePresentedViewController()
    PytoClasses.ConsoleViewController.isMainLoopRunning = False

